/*---- 15tgraph.c

14 april: graphics switched off, this is the same as tgraph9.c

---------------------*/


#include "threep9.h"

#define GRAPHICSON 0 // graphics on/off 

#define OUTPUTFILE 1

#if GRAPHICSON
   #include "gengrdef.h"
#endif

/* ==== globals ==== */
extern double gamlog,gamlog1,gamlog2;
extern long model;

/*==== end of local globals ====*/

#if GRAPHICSON

void graphplot(yobsno, n, pohat, Dvalflag, Dval, j0, j1, j2, j3)
double * yobsno;
long n;
double * pohat;
long Dvalflag;
double * Dval;
long j0, j1, j2, j3;

/*==== graph plot ====*/
{
extern long cdfavail;
extern long hitail;
extern double leftendvalue;
extern long componentmodel;
extern long numcomps;

double explicitcdf(double,double*);
double incompgam(double,double,double,long);
double gammalog(double, long);
double bigphi(double);
double fnf(double, double*, long);

/*==== ncotes call ====*/
double quanc8(double, double, double * );
/*====*/

char akey;
double alpha;
double aa,bb;
double accupercent;

double cellht, ct;
double cdf, cdflo,cdfhi,cdfmid;

double dstep;
double Dvalmax,Dvalmin;

long firstdrawnflag;   /*$$$$$*/
FILE * fd;
FILE * fp;

long i,ii;
long ifault = 0;

long j;

long n1,numpts,numpdfpts,numhistpts;

#if WATCOM
static double param[PSIZE];
static double pdfvalo[NSIZE];
static double histopdf[NSIZE];
#else
double param[PSIZE];
double pdfvalo[NSIZE];
double histopdf[NSIZE];
#endif

double pvalue;

double segval;

double * thetaptr;

double xaxislength;         /*$$$$$*/
double xscale,xstep,xsteppdf,xstephist;
double xt,x0,x1,xt0,xt1;
double xlo,xhi,xmid;

double yaxislength;         /*$$$$$*/
double ymax;
double yscale,ystep;       /*$$$$$*/
double y0;
double yt,yt0,yt1;

#if GRAPHICSON
Initgraphics();
#endif

/*=== ncotes error tolerance setup ===*/
// relerr=1e-6;
// aerr=0.0;   /* === abs error tol === */

#if GRAPHICSON
   dstep=HRES/( 200.*log( (double)n ) );
#endif

numpts = n;

/* === set range limits === */
 aa = leftendvalue;
 bb = yobsno[numpts];

 numpdfpts = 500;/*$$$$$ was 50 */
 numhistpts =  (numpts/2);
 if(numhistpts<5) numhistpts = 5;
 if(numhistpts>100) numhistpts = 100;


 /* == adjust the of x-axis ==*/
 x0 = aa;
 ymax = 0.0;
 /*- calc pdfvals and find the largest in the range to be drawn -*/
 for(ii=1;ii<=numpdfpts;ii++)
 {
    pdfvalo[ii] = fnf(x0,pohat,model);
    if( (ymax<pdfvalo[ii]) ) ymax = pdfvalo[ii];
//    if(ii<=10) printf("pdf(%ld/%ld)=%lf\n",ii,numpdfpts,pdfvalo[ii]);
//    if(ii==1) getch();
    x0+=(bb-aa)/numpdfpts;
//    x0 = yobsno[ii];
 }
 do
 {
  x0 += (bb-aa)/20;
 } while(fnf(x0,pohat,model) > ymax/500.0  );

 bb = x0;

 xsteppdf = (bb-aa)/numpdfpts;
 xstephist = (bb-aa)/numhistpts;

#if GRAPHICSON

 xaxislength=0.8*HRES;

 xscale= 0.8*HRES/(bb-aa);
 alpha = 0.1*HRES - xscale*aa;

 xstep=0.8*HRES/(numpts);

 yaxislength=VRES/1.2;

if(hitail==1 || hitail==0)
 yscale=-VRES/( 1.2*log(0.5/numpts) );
else
 yscale = VRES/(1.2);
 

ystep=VRES/(1.2*numpts);


/*---- plot axes ----*/
 n1=numpts/**1.2*/;

 for(ii=0;ii<=n1;ii++) /*- x-axis, with ticks -*/
   {
   movegen((float)(ii*xstep) , 0);
   drawgen((float)((ii+1)*xstep),0);
   drawgen((float)((ii+1)*xstep),(float)dstep);
   }

 for(ii=0;ii<=numpts-1;ii++) /*- y-axis with ticks -*/
   {
   movegen(0,  (float) (ii*ystep) );
   drawgen(0,  (float) ((ii+1)*ystep));
   drawgen((float)dstep, (float) ((ii+1)*ystep));
   }

 movegen(0,(float)yaxislength);
 drawgen((float)xaxislength,(float)yaxislength);

#endif

again:


#if OUTPUTFILE
fd = fopen("cdf.d","w");
fp = fopen("pdf.d","w");
#endif

if(Dvalflag==0 || Dvalflag==1)
   printf("OPTIMIZED PARAMS: # of Components = %d\n",numcomps);
else
   printf("INITIAL PARAMS: # of Components = %d\n",numcomps);


#if GRAPHICSON
/* ==== draw x-axis ==== */
setcolgen(WHITE);
movegen(xscale*bb+alpha, 0);
drawgen(0,0);
#endif

/*============ plot EDF ==============*/
#if OUTPUTFILE
/*   fprintf(fd,"%d\n",numpts);  ----output in original units */
;
#endif


#if GRAPHICSON

if(hitail==1 || hitail==0)
 yscale=-VRES/( 1.2*log(0.5/numpts) );
else
 yscale = VRES/(1.2);

 setcolgen(GREEN);
#endif

 for(ii=1;ii<=numpts;ii++)
   {
   xt=xscale*yobsno[ii] + alpha;
   if(hitail==0) yt=-yscale*log((ii-.5)/numpts);
   else if(hitail==1)
       yt=-yscale*log( 1.- (ii-.5)/numpts);
                                        /* plot -log-survivor function */
   else yt = yscale * (ii-0.5)/numpts;

#if GRAPHICSON
   movegen((float)(xt-dstep), (float)yt);
   drawgen((float)(xt+dstep), (float)yt);
   movegen((float)xt, (float)(yt-dstep) );
   drawgen((float)xt, (float)(yt+dstep) );
#endif

#if OUTPUTFILE
   fprintf(fd,"%lf\t %lf\n",yobsno[ii], yt/yscale);/* output in original units */
#endif   

   }
#if OUTPUTFILE
fprintf(fd,"//nc\n"); 
#endif
/*============ End of plot EDF ==============*/


/*=============== Draw Fitted CDF  ================*/
#if GRAPHICSON
setcolgen(LIGHTRED);
#endif

#if OUTPUTFILE
/* fprintf(fd,"%d\n",numpdfpts); */
#endif

cdf = 0.0;

#if GRAPHICSON
movegen(0,0);
#endif

firstdrawnflag = 1;

for(ii=1;ii<=numpdfpts;ii++)
   {
   switch(cdfavail)
     {
     case 0:
       xt = aa + 0.00001 + (ii-1)*xsteppdf;
       cdf =  quanc8(leftendvalue,xt,pohat);
       break;

     case 1:
       xt = aa + 0.00001 + (ii-1)*xsteppdf;
       cdf = explicitcdf(xt,pohat);
       break;
     }

   if(hitail==0) yt = -log(cdf+.00000001); /* plot -logsurvivor function */
   else if (hitail==1) yt = -log(1.0-cdf);
   else yt = cdf;

#if OUTPUTFILE
     fprintf(fd,"%lf\t %lf\n",xt, yt); /* in original units */
#endif

   yt = yscale*yt;
   xt = xscale*xt+alpha;

#if GRAPHICSON
   if(yt<VRES && yt>0 && xt<HRES && xt>0)
     {
     if(firstdrawnflag==1) /*$$$$$*/
       {
       firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
       }
     else
       drawgen( (float)(xt), (float)(yt) );
     }
#endif

   }
#if OUTPUTFILE
fprintf(fd,"//nc\n"); 
#endif
/*--- end of draw of fitted integrated cdf  ---*/


printf("Press key to continue (& for pdfvals) \n");
akey=getch();

/* ============= investigate the pdf ================ */
#if GRAPHICSON
clearscreengen();
#endif

if(Dvalflag==0 || Dvalflag==1)
   printf("OPTIMIZED PARAMS: # of Components = %d\n",numcomps);
else
   printf("INITIAL PARAMS: # of Components = %d\n",numcomps);

x0 = aa; /*=== x0 set to left end of chosen range ===*/

#if GRAPHICSON
yscale = VRES/(1.2);
#endif


ymax = 0.0;

/*- calc pdfvals and find the largest in the range to be drawn -*/
for(ii=1;ii<=numpdfpts;ii++)
{
   pdfvalo[ii] = fnf(x0,pohat,model);
   if( (ymax<pdfvalo[ii]) ) ymax = pdfvalo[ii];
   x0+=xsteppdf;
   
   if(akey=='&') printf("pdf(%lf)=%lf\n",x0,pdfvalo[ii]);
   
}

// printf("At A: ymax = %lf\n", ymax);

/*==================================================
 Set cellht. The area under the pdf is unity. If each obsn
contributes an area xstephist*cellht, and there are numpts
obsns, then numpts*xstephist*cellht = 1
===================================================*/

cellht = 1.0/xstephist/numpts; 

/* === calc histopdf array and check max === */
for(j=1;j<=numhistpts;j++)
{
   histopdf[j] = 0.0;
}

for(ii=1;ii<=numpts;ii++)
{
   j = numhistpts * (yobsno[ii]-aa-0.0001)/(bb-aa) + 1.0;
   if( j>=1 && j<=numhistpts)
      histopdf[j] += 1.0;
}

for(ii=1;ii<=numhistpts;ii++)
{
   histopdf[ii] *= cellht;
   if(ymax < histopdf[ii]) ymax = histopdf[ii];
}

// printf("At B: ymax = %lf\n", ymax);
// getchgen();

#if GRAPHICSON
/* ----- draw the x-axis ---- */
setcolgen(WHITE);
movegen(xscale*(bb-aa)+alpha, 0);
drawgen(0,0);
#endif

/* ============ draw the PDF =========== */
#if OUTPUTFILE
/* fprintf(fp,"%d\n",numpdfpts); */
#endif

firstdrawnflag = 1;  /*$$$$$*/
x0 = aa;

#if GRAPHICSON
setcolgen(YELLOW);
#endif

for(ii=1;ii<=numpdfpts;ii++)
{
   yt = yscale*pdfvalo[ii]/ymax;
   xt = xscale*x0+alpha;

#if OUTPUTFILE
     fprintf(fp,"%lf\t %12.8lf\n",x0, pdfvalo[ii] ); /* in original units */
#endif

#if GRAPHICSON
   if(yt<VRES && yt>0 && xt<HRES && xt>0)
     {
     if(firstdrawnflag==1) /*$$$$$*/
       {
       firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
       }
     else   drawgen( (float)(xt), (float)(yt) );
     }
#endif

   x0 += xsteppdf;
}
#if OUTPUTFILE
fprintf(fp,"//nc\n"); 
#endif
/*--- end of draw of fitted  pdf  ---*/

if(numcomps<=1) goto redrawlabel;

#if GRAPHICSON
printf("press key for components\n");
getchgen();
setcolgen(LIGHTBLUE);
#endif

/* ============ draw the PDF components ========== */
for(j = 1; j<=numcomps; j++)
{
#if GRAPHICSON
   setcolgen( (5+j)%14 );
#endif

   firstdrawnflag = 1;  /*$$$$$*/
   x0 = aa;
   thetaptr = &pohat[3*(j-1)];

   if(componentmodel==NORMAL)
   {
      x0 = pohat[3*(j-1)+1] - 4.0*pohat[3*(j-1)+2];
      x1 = 8.0*pohat[3*(j-1)+2]/numpdfpts;
      for(ii=1;ii<=numpdfpts;ii++)
      {
         y0 = thetaptr[3] * fnf(x0,thetaptr,componentmodel);
         yt = yscale * y0 / ymax;
         xt = xscale*x0+alpha;
#if OUTPUTFILE
         fprintf(fp,"%lf\t %12.8lf\n",x0, y0 ); /* in original units */
#endif

#if GRAPHICSON
         if(yt<VRES && yt>0 && xt0<HRES && xt0>0)
         {
            if(firstdrawnflag==1) /*$$$$$*/
            {
               firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
            }
            else   drawgen( (float)(xt), (float)(yt) );
         }
#endif
         x0 += x1;
      }
   }
   else
   {
      for(ii=1;ii<=numpdfpts;ii++)
      {
         y0 = thetaptr[3] * fnf(x0,thetaptr,componentmodel);
         yt = yscale * y0 / ymax;
         xt = xscale*x0+alpha;
#if OUTPUTFILE
         fprintf(fp,"%lf\t %12.8lf\n",x0, y0 ); /* in original units */
#endif

#if GRAPHICSON
         if(yt<VRES && yt>0 && xt0<HRES && xt0>0)
         {
            if(firstdrawnflag==1) /*$$$$$*/
            {
               firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
            }
            else   drawgen( (float)(xt), (float)(yt) );
         }
#endif

         x0 += xsteppdf;
      }
   }
#if OUTPUTFILE
   fprintf(fp,"//nc\n"); 
#endif

#if GRAPHICSON
   getchgen();
#endif

}/*- j: components -*/
/*--- end of draw of pdf components ---*/

redrawlabel:
/* ============ Redraw the PDF =========== */
firstdrawnflag = 1;  /*$$$$$*/
x0 = aa;

#if GRAPHICSON
setcolgen(YELLOW);
#endif

for(ii=1;ii<=numpdfpts;ii++)
{
   yt = yscale*pdfvalo[ii]/ymax;
   xt = xscale*x0+alpha;

#if GRAPHICSON
   if(yt<VRES && yt>0 && xt0<HRES && xt0>0)
     {
     if(firstdrawnflag==1) /*$$$$$*/
       {
       firstdrawnflag = 0; movegen( (float)(xt), (float)(yt) );
       }
     else   drawgen( (float)(xt), (float)(yt) );
     }
#endif

   x0 += xsteppdf;
}
/*--- end of redraw of fitted  pdf  ---*/

#if GRAPHICSON
printf("press key for histogram\n");
getchgen();

setcolgen(RED);
#endif

x0 = aa;

/*--- draw the histogram ---*/
#if OUTPUTFILE
/* fprintf(fp,"%d\n",2*numhistpts+2 ); */
#endif

for(ii=1;ii<=numhistpts;ii++)
   {
   x1 = x0 + xstephist;

#if OUTPUTFILE
     if(ii==1)
       {
       fprintf(fp,"%lf\t %12.8lf\n",x0, 0.0);           /* in original units */
       fprintf(fp,"%lf\t %12.8lf\n",x0, histopdf[ii] );
       fprintf(fp,"%lf\t %12.8lf\n",x1, histopdf[ii] );
       }
     else if (ii<numhistpts)
       {
       fprintf(fp,"%lf\t %12.8lf\n",x0, histopdf[ii] ); /* in original units */
       fprintf(fp,"%lf\t %12.8lf\n",x1, histopdf[ii] );
       }       
     else
       {
       fprintf(fp,"%lf\t %12.8lf\n",x0, histopdf[ii] ); /* in original units */
       fprintf(fp,"%lf\t %12.8lf\n",x1, histopdf[ii] );
       fprintf(fp,"%lf\t %12.8lf\n",x1, 0.0 );
       }       
#endif

   xt0 = xscale*x0+alpha;
   xt1 = xscale*x1+alpha;
  
   x0 += xstephist;

   yt1 = yscale*histopdf[ii]/ymax;

#if GRAPHICSON
     if(ii==1) /*$$$$$*/
       {
       movegen( (float)(xt0), (float)(0) );
       drawgen( (float)(xt0), (float)(yt1) );
       drawgen( (float)(xt1), (float)(yt1) );
       }
     else if (ii<numhistpts)
       {
       drawgen( (float)(xt0), (float)(yt1) );
       drawgen( (float)(xt1), (float)(yt1) );
       }       
     else
       {
       drawgen( (float)(xt0), (float)(yt1) );
       drawgen( (float)(xt1), (float)(yt1) );
       drawgen( (float)(xt1), (float)(0) );
       }       
#endif

   }

#if OUTPUTFILE
fprintf(fp,"//nc\n"); 
#endif

#if OUTPUTFILE
fclose(fd);
fclose(fp);
#endif

#if GRAPHICSON
 if(Dvalflag==0 || Dvalflag==1)
 {
    printf("End of plots with this # of components. Yes to continue\n");
    printf("Press R to  Redraw plots\n");
    akey = getchgen();
    if( (akey=='R') || (akey=='r') )
    {
       printf("xmin = %lf xmax = %lf Select new values\n",aa,bb);
       scanf("%lf %lf", &aa, &bb);
       /*
       if(aa<leftendvalue) aa=leftendvalue;
       */
       printf("numhistpts= %d. Select new value\n",numhistpts);
       scanf("%d",&numhistpts);
       xscale=0.8*HRES/(bb-aa);
       alpha = 0.1*HRES - xscale*aa;
       xstephist = (bb-aa)/numhistpts;
       xsteppdf = (bb-aa)/numpdfpts;
       clearscreengen();
       goto again;
    } 
 }
 else
 {
    printf("Press key\n");
    akey=getchgen();
 }
#endif

#if 0
/*======================================*/

/* ==== look at Dval: differences between fitted cdf and edf ===== */
if (Dvalflag==0) goto skipDlabel;
clearscreengen();
if(Dvalflag==0 || Dvalflag==1)
   printf("OPTIMIZED PARAMS: # of Components = %d\n",numcomps);
else
   printf("INITIAL PARAMS: # of Components = %d\n",numcomps);

 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 for(ii=1;ii<numpts;ii++)
 {
    xt=xscale*yobsno[ii] + alpha;
    xt1=xscale*yobsno[ii+1] + alpha;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(j0<=ii && ii<=j1)
    {
       if(j2<=ii && ii<=j3)
          setcolgen(YELLOW);
       else
          setcolgen(RED);
    }
    else
    {
       if(j2<=ii && ii<=j3)
          setcolgen(MAGENTA);
       else
          setcolgen(CYAN);
    }
    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)xt1, yt);

 /* ==== look at Dval: differences between fitted cdf and edf ===== */
 clearscreengen();
 if(Dvalflag==0 || Dvalflag==1)
    printf("OPTIMIZED PARAMS: # of Components = %d\n",numcomps);
 else
    printf("INITIAL PARAMS: # of Components = %d\n",numcomps);

 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 for(ii=1;ii<numpts;ii++)
 {
    xt=(HRES/1.2)*(double)ii/n + (0.1/1.2)*HRES;
    xt1=(HRES/1.2)*(double)(ii+1.)/n + (0.1/1.2)*HRES;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(j0<=ii && ii<=j1)
    {
       if(j2<=ii && ii<=j3)
          setcolgen(YELLOW);
       else
          setcolgen(RED);
    }
    else
    {
       if(j2<=ii && ii<=j3)
          setcolgen(MAGENTA);
       else
          setcolgen(CYAN);
    }

    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)(xt1), (float)yt);

getchgen();

skipDlabel:
/*======================================*/


#endif

#if GRAPHICSON
   Closegraphics();
#endif

;

}
/*-- end of graphplot --*/

#endif


/* ==================== Dvalplot2 ==================================
 This version plots simultaneous segments

 If entered with adjustonflag=0, there is no adjustment and no graphics output
 If entered with adjustonflag=1, there is adjustment and graphics output

 exits with adjustonflag = 0 if enters with adjustonflag == 0

============================================================ */

void Dvalplot2(
   long * adjustonflagptr,
   double * yobsno,
   long n,
   double * Dval,
   double* maxprobsofar,
   double* maxprobsofar1,
   long* j0, long* j1, long* j2, long* j3
)


/*==== graph plot ====*/
{

extern double leftendvalue;

static char akey;
static double alpha;
static double aa,bb;

static long col;

static double Dvalmax,Dvalmin;
static double Dold, Dnew;

static long i, j, ii;
static long ifault = 0;
static long intvlon;

static long j0temp, j1temp;
static long jstart;

static long numpts;
static long numintvlsset;

static double Dintvl;
static double dmin;

static long segcount0;

static long segcol[NSIZE];

static double xscale;
static double xt,xt1;

static double ymax;
static double yscale,ystep;       /*$$$$$*/
static double yt,yt1;

numpts = n;

    *maxprobsofar=0;
    for(i=1;i<n;i++)
    {
       dmin = Dval[i];
       for(j=i+1;j<=n;j++)
       {
          if(Dval[j]-dmin>*maxprobsofar)
          {
             *j0 = i;
             *j1 = j;
             *maxprobsofar=Dval[j]-dmin;
          }
       }
    }

    *maxprobsofar1=0.0;
    for(i=1;i<n;i++)
    {
       dmin = Dval[i];
       for(j=i+1;j<=n;j++)
       {
          if(Dval[j]-dmin>*maxprobsofar1 && ( (i<*j0 && j<*j0) || (*j1<i && *j1<j) ) )
          {
             *j2 = i;
             *j3 = j;
             *maxprobsofar1=Dval[j]-dmin;
          }
       }
    }
    /*
    printf("j0=%d j1=%d prob=%lf j2=%d j3=%d prob1=%lf\n",
            *j0,*j1,*maxprobsofar,*j2,*j3,*maxprobsofar1);
    */



 /* --- identify largest and smallest Dval --- */
 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }


/* ==== look at Dval: differences between fitted cdf and edf ===== */
 yt1 = 0.0;
 for(ii=1;ii<=numpts;ii++)
 {
    yt = Dval[ii];
    // compare this yt with previous one   
    if(yt>=yt1)
    {
       segcol[ii] = 1;
    }
    else
    {
       segcol[ii] = 0;
    }
    yt1 = yt;
 }

#if GRAPHICSON

repeatlabel:

if(*adjustonflagptr==1)
{

Initgraphics();
/* === set range limits === */
 aa = leftendvalue;
 bb = yobsno[numpts];

 xscale= 0.8*HRES/(bb-aa);
 alpha = 0.1*HRES - xscale*aa;

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /* ==== draw x-axis ==== */
 setcolgen(WHITE);
 movegen(xscale*bb+alpha, 0);
 drawgen(0,0);

 clearscreengen();

 printf("Adjust with a,s-j1 z,x-j0; Yellow segment\n");
 printf("            d,f-j3 c,v-j2; Red segment\n");
 printf(" y-try this one\n");
 printf("j0=%ld j1=%ld j2=%ld j3=%ld\n",*j0,*j1,*j2,*j3);
 printf("D0=%lf D1=%lf\n", *maxprobsofar, *maxprobsofar1);
 printf("Yellow largest, red 2nd; cyan, blue & green omitted\n");

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 setcolgen(CYAN);
 col = 4;
 for(ii=1;ii<numpts;ii++)
 {
    xt=xscale*yobsno[ii] + alpha;
    xt1=xscale*yobsno[ii+1] + alpha;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;
    // compare this yt with previous one   
    if(ii==*j1+1) // The colour is the ii we are drawing to i.e. ii+1
    {
       col = 0;
    }
    if(ii==*j3+1)
    {
       col = 0;
    }
    if(ii==*j0+1)
    {
       col = 1;
    }
    if(ii==*j2+1)
    {
       col = 2;
    }
   
    if(col==0)
    {
       if(segcol[ii]==1) setcolgen(GREEN);
       else setcolgen(BLUE);
    }
    if(col==1) setcolgen(YELLOW);
    if(col==2) setcolgen(RED);
    if(col==4) setcolgen(CYAN);

    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }

 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)xt1, yt);

 akey=getchgen();
 switch(akey)
 {
    case 'a': *j1=*j1-1; if(*j1<=*j0) *j1=*j1+1; break;
    case 's': *j1=*j1+1; if(*j1>numpts) *j1=*j1-1; break;
    case 'z': *j0=*j0-1; if(*j0<0) *j0=*j0+1; break;
    case 'x': *j0=*j0+1; if(*j0>=*j1) *j0=*j0-1; break;

    case 'd': *j3=*j3-1; if(*j3<=*j2) *j3=*j3+1; break;
    case 'f': *j3=*j3+1; if(*j3>numpts) *j3=*j3-1; break;
    case 'c': *j2=*j2-1; if(*j2<0)      *j2=*j2+1; break;
    case 'v': *j2=*j2+1; if(*j2>=*j3) *j2=*j2-1; break;

    case 'y': *adjustonflagptr = 0; break; /* -- end adjusts -- */
    default: ;
 }
 *maxprobsofar = Dval[*j1] - Dval[*j0];
 *maxprobsofar1 = Dval[*j3] - Dval[*j2];

 if (*adjustonflagptr==1) goto repeatlabel;

/* ==== Second look at Dval: differences between fitted cdf and edf ===== */
/* ===== here ranks are used for the x values rather than the obsns ===== */
repeat2:

 *adjustonflagptr = 1;

 clearscreengen();

 printf("Adjust with a,s-j1 z,x-j0; Yellow segment\n");
 printf("            d,f-j3 c,v-j2; Red segment\n");
 printf(" y-try this one\n");
 printf("j0=%ld j1=%ld j2=%ld j3=%ld\n",*j0,*j1,*j2,*j3);
 printf("D0=%lf D1=%lf\n", *maxprobsofar, *maxprobsofar1);
 printf("Yellow largest, red 2nd; cyan, blue & green omitted\n");

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 setcolgen(CYAN);
 col = 4;
 for(ii=1;ii<numpts;ii++)
 {
    xt=(HRES/1.2)*(double)ii/n + (0.1/1.2)*HRES;
    xt1=(HRES/1.2)*(double)(ii+1.)/n + (0.1/1.2)*HRES;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(ii==*j1+1)
    {
       col = 0;
    }
    if(ii==*j3+1)
    {
       col = 0;
    }
    if(ii==*j0+1)
    {
       col = 1;
    }
    if(ii==*j2+1)
    {
       col = 2;
    }
   
    if(col==0)
    {
       if(segcol[ii]==1) setcolgen(GREEN);
       else setcolgen(BLUE);
    }
    if(col==1) setcolgen(YELLOW);
    if(col==2) setcolgen(RED);
    if(col==4) setcolgen(CYAN);

    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)(xt1), (float)yt);

 akey=getchgen();
 switch(akey)
 {
    case 'a': *j1=*j1-1; if(*j1<=*j0) *j1=*j1+1; break;
    case 's': *j1=*j1+1; if(*j1>numpts) *j1=*j1-1; break;
    case 'z': *j0=*j0-1; if(*j0<0) *j0=*j0+1; break;
    case 'x': *j0=*j0+1; if(*j0>=*j1) *j0=*j0-1; break;

    case 'd': *j3=*j3-1; if(*j3<=*j2) *j3=*j3+1; break;
    case 'f': *j3=*j3+1; if(*j3>numpts) *j3=*j3-1; break;
    case 'c': *j2=*j2-1; if(*j2<0)      *j2=*j2+1; break;
    case 'v': *j2=*j2+1; if(*j2>=*j3) *j2=*j2-1; break;

    case 'y': *adjustonflagptr = 0; break; /* -- end adjusts -- */
    default: ;   /* -- exit & try this setting -- */
 }
 *maxprobsofar = Dval[*j1] - Dval[*j0];
 *maxprobsofar1 = Dval[*j3] - Dval[*j2];

 if (*adjustonflagptr==1) goto repeat2;

 *adjustonflagptr = 1;

 Closegraphics();

}/* adjustonflag */
#endif

}
/* ------- end of Dvalplot2 ------ */

#if 0
// ========================================================
void Dvalplot(yobsno, n, pohat, adjustonflagptr, Dval, j0ptr, j1ptr, maxprobptr)
double * yobsno;
long n;
double * pohat;
long * adjustonflagptr;
double * Dval;
long * j0ptr, * j1ptr;
double * maxprobptr;

/*==== graph plot ====*/
{

extern double leftendvalue;


char akey;
double alpha;
double aa,bb;

double Dvalmax,Dvalmin;

long i,ii;
long ifault = 0;


long numpts;

double xscale;
double xt,xt1;

double ymax;
double yscale,ystep;       /*$$$$$*/
double yt,yt1;

Initgraphics();

numpts = n;

/* === set range limits === */
 aa = leftendvalue;
 bb = yobsno[numpts];

 xscale= 0.8*HRES/(bb-aa);
 alpha = 0.1*HRES - xscale*aa;

/* ==== draw x-axis ==== */
setcolgen(WHITE);
movegen(xscale*bb+alpha, 0);
drawgen(0,0);

/* ==== look at Dval: differences between fitted cdf and edf ===== */
clearscreengen();
printf("Adjust with a,s-j1 z,x-j0; y-try this one; e- to escape Dval loop\n");
printf("            d,f-j1 c,v-j0; (steplength 10)\n");
printf("Adjust with g,h-j1 b,n-j0; (steplength 100)\n");

*adjustonflagptr=2;
repeatlabel:
 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 for(ii=1;ii<numpts;ii++)
 {
    xt=xscale*yobsno[ii] + alpha;
    xt1=xscale*yobsno[ii+1] + alpha;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(*j0ptr<=ii && ii<*j1ptr)
    {
       setcolgen(RED);
    }
    else
    {
       setcolgen(CYAN);
    }
    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)xt1, yt);

 akey=getchgen();
 switch(akey)
 {
    case 'a': *j1ptr=*j1ptr-1; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+1; break;
    case 's': *j1ptr=*j1ptr+1; if(*j1ptr>numpts) *j1ptr=*j1ptr-1; break;
    case 'z': *j0ptr=*j0ptr-1; if(*j0ptr<0) *j0ptr=*j0ptr+1; break;
    case 'x': *j0ptr=*j0ptr+1; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-1; break;

    case 'd': *j1ptr=*j1ptr-10; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+10; break;
    case 'f': *j1ptr=*j1ptr+10; if(*j1ptr>numpts) *j1ptr=*j1ptr-10; break;
    case 'c': *j0ptr=*j0ptr-10; if(*j0ptr<0)      *j0ptr=*j0ptr+10; break;
    case 'v': *j0ptr=*j0ptr+10; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-10; break;

    case 'g': *j1ptr=*j1ptr-100; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+100; break;
    case 'h': *j1ptr=*j1ptr+100; if(*j1ptr>numpts) *j1ptr=*j1ptr-100; break;
    case 'b': *j0ptr=*j0ptr-100; if(*j0ptr<0)      *j0ptr=*j0ptr+100; break;
    case 'n': *j0ptr=*j0ptr+100; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-100; break;

    case 'e': *adjustonflagptr = 0; break; /* -- end adjusts -- */
    default: *adjustonflagptr = 1;   /* -- try this one -- */
 }
 if (*adjustonflagptr==2) goto repeatlabel;

 /* ==== look at Dval: differences between fitted cdf and edf ===== */
 clearscreengen();

 printf("Adjust with a,s-j1 z,x-j0; y-try this one; e- to escape Dval loop\n");
 printf("            d,f-j1 c,v-j0; (steplength 10)\n");
 printf("Adjust with g,h-j1 b,n-j0; (steplength 100)\n");

 *adjustonflagptr=2;
repeat2:
 Dvalmax = -1e10;
 Dvalmin =  1e10;
 for(i=1;i<=numpts;i++)
 {
    if(Dval[i]>Dvalmax) Dvalmax = Dval[i];   
    if(Dval[i]<Dvalmin) Dvalmin = Dval[i];   
 }

 yscale = VRES/(1.2*(Dvalmax-Dvalmin));

 /*-- draw horizontal axis at Dval = 0 --*/
 setcolgen(WHITE);
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 movegen(0, (float)yt);
 drawgen(HRESM1,(float)yt);

 yt1 = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 for(ii=1;ii<numpts;ii++)
 {
    xt=(HRES/1.2)*(double)ii/n + (0.1/1.2)*HRES;
    xt1=(HRES/1.2)*(double)(ii+1.)/n + (0.1/1.2)*HRES;
    yt = yscale * (Dval[ii]-Dvalmin) + (0.1/1.2)*VRES;

    if(*j0ptr<=ii && ii<*j1ptr)
    {
       setcolgen(RED);
    }
    else
    {
       setcolgen(CYAN);
    }

    if(ii==1)   movegen((float)(xt), (float)yt1);
    drawgen((float)(xt), (float)yt);
    drawgen((float)(xt1), (float)yt);
    yt1 = yt;
 }
 yt = yscale * (0.0-Dvalmin) + (0.1/1.2)*VRES;
 drawgen((float)(xt1), (float)yt);

 akey=getchgen();
 switch(akey)
 {
    case 'a': *j1ptr=*j1ptr-1; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+1; break;
    case 's': *j1ptr=*j1ptr+1; if(*j1ptr>numpts) *j1ptr=*j1ptr-1; break;
    case 'z': *j0ptr=*j0ptr-1; if(*j0ptr<0) *j0ptr=*j0ptr+1; break;
    case 'x': *j0ptr=*j0ptr+1; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-1; break;

    case 'd': *j1ptr=*j1ptr-10; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+10; break;
    case 'f': *j1ptr=*j1ptr+10; if(*j1ptr>numpts) *j1ptr=*j1ptr-10; break;
    case 'c': *j0ptr=*j0ptr-10; if(*j0ptr<0)      *j0ptr=*j0ptr+10; break;
    case 'v': *j0ptr=*j0ptr+10; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-10; break;

    case 'g': *j1ptr=*j1ptr-100; if(*j1ptr<=*j0ptr) *j1ptr=*j1ptr+100; break;
    case 'h': *j1ptr=*j1ptr+100; if(*j1ptr>numpts) *j1ptr=*j1ptr-100; break;
    case 'b': *j0ptr=*j0ptr-100; if(*j0ptr<0)      *j0ptr=*j0ptr+100; break;
    case 'n': *j0ptr=*j0ptr+100; if(*j0ptr>=*j1ptr) *j0ptr=*j0ptr-100; break;

    case 'e': *adjustonflagptr = 0; break; /* -- end adjusts -- */
    default: *adjustonflagptr = 1;   /* -- try this one -- */
 }
 if (*adjustonflagptr==2) goto repeat2;

*maxprobptr = Dval[*j1ptr]-Dval[*j0ptr];
if(*maxprobptr<=0.0) *maxprobptr = 0.01;

Closegraphics();

}
/* ------- end of Dvalplot ------ */
#endif

